| Oyranos Colour Management System API

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
oyFilterPlug_s Struct Reference
DAG and Image processing API

A filter connection structure. More...

`#include <oyFilterPlug_s.h>`

Inheritance diagram for oyFilterPlug_s:
Collaboration diagram for oyFilterPlug_s:

## Public Member Functions
OYAPI oyFilterPlug_s *OYEXPORT | oyFilterPlug_New (oyObject_s object)
| allocate a new FilterPlug object More...
OYAPI oyFilterPlug_s *OYEXPORT | oyFilterPlug_Copy (oyFilterPlug_s *filterplug, oyObject_s object)
| copy or reference a FilterPlug object More...
OYAPI int OYEXPORT | oyFilterPlug_Release (oyFilterPlug_s **filterplug)
| release and possibly deallocate a oyFilterPlug_s object More...
OYAPI int OYEXPORT | oyFilterPlug_Callback (oyFilterPlug_s *c, oyCONNECTOR_EVENT_e e)
| Tell about a oyConversion_s event. More...
OYAPI int OYEXPORT | oyFilterPlug_ConnectIntoSocket (oyFilterPlug_s **p, oyFilterSocket_s **s)
| Connect a oyFilterPlug_s with a oyFilterSocket_s. More...
OYAPI oyFilterNode_s *OYEXPORT | oyFilterPlug_GetNode (oyFilterPlug_s *plug)
| Access oyFilterPlug_s::node. More...
OYAPI oyFilterNode_s *OYEXPORT | oyFilterPlug_GetRemoteNode (oyFilterPlug_s *plug)
| Access oyFilterPlug_s::remote_socket::node. More...
OYAPI oyFilterSocket_s *OYEXPORT | oyFilterPlug_GetSocket (oyFilterPlug_s *plug)
| Access oyFilterPlug_s::remote_socket_. More...
OYAPI oyConnector_s *OYEXPORT | oyFilterPlug_GetPattern (oyFilterPlug_s *plug)
| Access oyFilterPlug_s::pattern. More...
OYAPI const char *OYEXPORT | oyFilterPlug_GetRelatives (oyFilterPlug_s *plug)
| get short description of belonging filter More...
OYAPI oyConnector_s *OYEXPORT | oyFilterSocket_GetPattern (oyFilterSocket_s *socket)
| Access oyFilterPlug_s::pattern. More...
OYAPI oyImage_s *OYEXPORT | oyFilterPlug_ResolveImage (oyFilterPlug_s *plug, oyFilterSocket_s *socket, oyPixelAccess_s *ticket)
| Resolve processing data during a filter run. More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get a text dump More...

## Data Fields
oyStruct_Copy_f | copy
oyStruct_Release_f | release
Data Fields inherited from oyStruct_s
oyStruct_Copy_f | copy
oyStruct_Release_f | release

## Detailed Description

A filter connection structure.

The active input version of a oyConnector_s. Each plug can connect to exact one socket.

Version
  Oyranos: 0.1.8

Since
  2008/07/29 (Oyranos: 0.1.8)

Date
  2008/07/29

## Member Function Documentation

OYAPI int OYEXPORT oyFilterPlug_Callback | ( | oyFilterPlug_s * | c,
|  | oyCONNECTOR_EVENT_e | e
| ) |  |

Tell about a oyConversion_s event.

Function oyFilterPlug_Callback

Parameters

  [in,out] | c | the connector
  | e | the event type

Version
  Oyranos: 0.1.8

Since
  2008/07/28 (Oyranos: 0.1.8)

Date
  2008/07/28

OYAPI int OYEXPORT oyFilterPlug_ConnectIntoSocket | ( | oyFilterPlug_s ** | p,
|  | oyFilterSocket_s ** | s
| ) |  |

Connect a oyFilterPlug_s with a oyFilterSocket_s.

Function oyFilterPlug_ConnectIntoSocket

Version
  Oyranos: 0.1.8

Since
  2008/07/30 (Oyranos: 0.1.8)

Date
  2008/07/31

References oyFilterPlugs_s::oyFilterPlugs_MoveIn(), oyFilterPlugs_s::oyFilterPlugs_New(), oyFilterSocket_s::oyFilterSocket_Callback(), oyFilterSocket_s::oyFilterSocket_Release(), and oyStructTypeToText().

Referenced by oyFilterNode_s::oyFilterNode_Connect().

OYAPI oyFilterPlug_s *OYEXPORT oyFilterPlug_Copy | ( | oyFilterPlug_s * | filterplug,
|  | oyObject_s | object
| ) |  |

copy or reference a FilterPlug object

Function oyFilterPlug_Copy

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | filterplug | FilterPlug struct object
  | object | NULL - means reference, the optional object triggers a real copy

References oyOBJECT_FILTER_PLUG_S.

Referenced by oyFilterNode_s::oyFilterNode_GetPlug().

OYAPI oyFilterNode_s *OYEXPORT oyFilterPlug_GetNode | ( | oyFilterPlug_s * | plug | ) |

Access oyFilterPlug_s::node.

Function oyFilterPlug_GetNode

Parameters

  [in] | plug | the plug

Returns
  the node

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyFilterNode_s::oyFilterNode_Copy(), and oyOBJECT_FILTER_PLUG_S.

OYAPI oyConnector_s *OYEXPORT oyFilterPlug_GetPattern | ( | oyFilterPlug_s * | plug | ) |

Access oyFilterPlug_s::pattern.

Function oyFilterPlug_GetPattern

Parameters

  [in] | plug | the plug

Returns
  capabilities pattern for this filter plug

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyConnector_s::oyConnector_Copy(), and oyOBJECT_FILTER_PLUG_S.

OYAPI const char *OYEXPORT oyFilterPlug_GetRelatives | ( | oyFilterPlug_s * | plug | ) |

get short description of belonging filter

Function oyFilterPlug_GetRelatives

Parameters

  [in] | plug | the plug

Returns
  short text

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyOBJECT_FILTER_PLUG_S.

OYAPI oyFilterNode_s *OYEXPORT oyFilterPlug_GetRemoteNode | ( | oyFilterPlug_s * | plug | ) |

Access oyFilterPlug_s::remote_socket::node.

Function oyFilterPlug_GetRemoteNode

Parameters

  [in] | plug | the plug

Returns
  the remote node

Version
  Oyranos: 0.5.0

Date
  2012/09/24

Since
  2012/09/24 (Oyranos: 0.5.0)

References oyFilterSocket_s::oyFilterSocket_GetNode(), and oyOBJECT_FILTER_PLUG_S.

OYAPI oyFilterSocket_s *OYEXPORT oyFilterPlug_GetSocket | ( | oyFilterPlug_s * | plug | ) |

Access oyFilterPlug_s::remote_socket_.

Function oyFilterPlug_GetSocket

Parameters

  [in] | plug | the plug

Returns
  the remote socket

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyFilterSocket_s::oyFilterSocket_Copy(), and oyOBJECT_FILTER_PLUG_S.

OYAPI oyFilterPlug_s *OYEXPORT oyFilterPlug_New | ( | oyObject_s | object | ) |

allocate a new FilterPlug object

Function oyFilterPlug_New

References oyOBJECT_OBJECT_S.

Referenced by oyFilterNode_s::oyFilterNode_GetPlug().

OYAPI int OYEXPORT oyFilterPlug_Release | ( | oyFilterPlug_s ** | filterplug | ) |

release and possibly deallocate a oyFilterPlug_s object

Function oyFilterPlug_Release

Parameters

  [in,out] | filterplug | FilterPlug struct object

References oyOBJECT_FILTER_PLUG_S.

Referenced by oyConversion_s::oyConversion_GetImage(), oyConversion_s::oyConversion_GetOnePixel(), oyConversion_s::oyConversion_RunPixels(), oyFilterGraph_s::oyFilterGraph_ToText(), oyFilterNode_s::oyFilterNode_GetSocketNode(), oyFilterSocket_s::oyFilterSocket_Callback(), and oyFilterSocket_s::oyFilterSocket_SignalToGraph().

OYAPI oyImage_s *OYEXPORT oyFilterPlug_ResolveImage | ( | oyFilterPlug_s * | plug,
|  | oyFilterSocket_s * | socket,
|  | oyPixelAccess_s * | ticket
| ) |  |

Resolve processing data during a filter run.

Function oyFilterPlug_ResolveImage

The function is a convenience function to use inside a filters oyCMMFilterPlug_Run_f call. The function makes only sense for non root filters.

Parameters

  [in,out] | plug | the filters own plug
  [in,out] | socket | the filters own socket
  [in,out] | ticket | the actual ticket

Returns
  the input image

Version
  Oyranos: 0.1.10

Since
  2009/05/01 (Oyranos: 0.1.10)

Date
  2009/05/01

References oyBOOLEAN_INTERSECTION, oyBOOLEAN_UNION, oyChannels_m, oyDataType_m, oyFilterNode_s::oyFilterNode_GetOptions(), oyFilterNode_s::oyFilterNode_SetData(), oyImage_s::oyImage_Copy(), oyImage_s::oyImage_Create(), oyImage_s::oyImage_Release(), oyOptions_s::oyOptions_CopyFrom(), oyOptions_s::oyOptions_Filter(), oyOptions_s::oyOptions_FindInt(), oyOptions_s::oyOptions_Release(), oyProfile_s::oyProfile_GetChannelsCount(), oyToChannels_m, and oyToDataType_m.

Referenced by oyConversion_s::oyConversion_RunPixels().

OYAPI oyConnector_s *OYEXPORT oyFilterSocket_GetPattern | ( | oyFilterSocket_s * | socket | ) |

Access oyFilterPlug_s::pattern.

Function oyFilterPlug_GetPattern

Parameters

  [in] | socket | the socket

Returns
  capabilities pattern for this filter socket

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyConnector_s::oyConnector_Copy(), and oyOBJECT_FILTER_SOCKET_S.

## Field Documentation

oyStruct_Copy_f oyFilterPlug_s::copy

copy function

oyStruct_Release_f oyFilterPlug_s::release

release function